//
// Copyright (C) 2006, NinjaTrader LLC <ninjatrader@ninjatrader.com>.
// NinjaTrader reserves the right to modify or overwrite this NinjaScript component with each release.
//

#region Using declarations
using System;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private OrderFlowsTrader[] cacheOrderFlowsTrader = null;

        private static OrderFlowsTrader checkOrderFlowsTrader = new OrderFlowsTrader();

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public OrderFlowsTrader OrderFlowsTrader(NinjaTrader.Indicator.OrderFlowsTrader.BarDisplayTypeEnum barDisplayType, int bidAskHistogramSize, Color blockTradeAskLineColor, Color blockTradeBidLineColor, Font blockTradeFont, DashStyle blockTradeLineDashStyle, int blockTradeLineWidth, int blockTradeSizeFilter, bool displayImbalanceClusters, bool displayReversalBar, bool displaySummaryPanelAsk, bool displaySummaryPanelBarVolume, bool displaySummaryPanelBid, bool displaySummaryPanelCumDelta, bool displaySummaryPanelCumDeltaByVolume, bool displaySummaryPanelDelta, bool displaySummaryPanelMaxDelta, bool displaySummaryPanelMinDelta, bool displaySummaryPanelTotalVolume, bool displayVolumeProfile, bool enableDetectUnfinishedJob, Color gridColor, Color highestVolumeCellColor, Color imbalanceClusterAskLineColor, Color imbalanceClusterBidLineColor, int imbalanceClusterBoxSize, DashStyle imbalanceClusterLineDashStyle, int imbalanceClusterLineWidth, int imbalanceClusterSize, int imbalanceInPercent, Color imbalanceTextColorAsk, Color imbalanceTextColorBid, int imbalanceVolumeThreshold, Color ladderAskBarStripeColor, Color ladderAskCellBackgroundColor, Color ladderBidBarStripeColor, Color ladderBidCellBackgroundColor, bool loadHistoricalData, bool markHighestVolumeCellColor, double ratioBoundsHigh, double ratioBoundsLow, Font ratioFont, Color ratioOutOfBoundsColor, Color singlePrintBoxColorBottom, int singlePrintBoxColorOpacity, Color singlePrintBoxColorTop, int sizeFilter, Color summaryAskCellBackgroundColor, Color summaryBidCellBackgroundColor, Color summaryDeltaCellBackgroundColor, Font summaryFont, Color summaryHeaderColor, Color summaryVolumeCellBackgroundColor, Color textColor, Color unfinishedJobHighLineColor, DashStyle unfinishedJobLineDashStyle, int unfinishedJobLineWidth, Color unfinishedJobLowLineColor, Font volumeImbalanceFont, Color volumeProfileAskColor, Color volumeProfileBidColor, int volumeProfileOpacity, Color volumeProfileTotalColor)
        {
            return OrderFlowsTrader(Input, barDisplayType, bidAskHistogramSize, blockTradeAskLineColor, blockTradeBidLineColor, blockTradeFont, blockTradeLineDashStyle, blockTradeLineWidth, blockTradeSizeFilter, displayImbalanceClusters, displayReversalBar, displaySummaryPanelAsk, displaySummaryPanelBarVolume, displaySummaryPanelBid, displaySummaryPanelCumDelta, displaySummaryPanelCumDeltaByVolume, displaySummaryPanelDelta, displaySummaryPanelMaxDelta, displaySummaryPanelMinDelta, displaySummaryPanelTotalVolume, displayVolumeProfile, enableDetectUnfinishedJob, gridColor, highestVolumeCellColor, imbalanceClusterAskLineColor, imbalanceClusterBidLineColor, imbalanceClusterBoxSize, imbalanceClusterLineDashStyle, imbalanceClusterLineWidth, imbalanceClusterSize, imbalanceInPercent, imbalanceTextColorAsk, imbalanceTextColorBid, imbalanceVolumeThreshold, ladderAskBarStripeColor, ladderAskCellBackgroundColor, ladderBidBarStripeColor, ladderBidCellBackgroundColor, loadHistoricalData, markHighestVolumeCellColor, ratioBoundsHigh, ratioBoundsLow, ratioFont, ratioOutOfBoundsColor, singlePrintBoxColorBottom, singlePrintBoxColorOpacity, singlePrintBoxColorTop, sizeFilter, summaryAskCellBackgroundColor, summaryBidCellBackgroundColor, summaryDeltaCellBackgroundColor, summaryFont, summaryHeaderColor, summaryVolumeCellBackgroundColor, textColor, unfinishedJobHighLineColor, unfinishedJobLineDashStyle, unfinishedJobLineWidth, unfinishedJobLowLineColor, volumeImbalanceFont, volumeProfileAskColor, volumeProfileBidColor, volumeProfileOpacity, volumeProfileTotalColor);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public OrderFlowsTrader OrderFlowsTrader(Data.IDataSeries input, NinjaTrader.Indicator.OrderFlowsTrader.BarDisplayTypeEnum barDisplayType, int bidAskHistogramSize, Color blockTradeAskLineColor, Color blockTradeBidLineColor, Font blockTradeFont, DashStyle blockTradeLineDashStyle, int blockTradeLineWidth, int blockTradeSizeFilter, bool displayImbalanceClusters, bool displayReversalBar, bool displaySummaryPanelAsk, bool displaySummaryPanelBarVolume, bool displaySummaryPanelBid, bool displaySummaryPanelCumDelta, bool displaySummaryPanelCumDeltaByVolume, bool displaySummaryPanelDelta, bool displaySummaryPanelMaxDelta, bool displaySummaryPanelMinDelta, bool displaySummaryPanelTotalVolume, bool displayVolumeProfile, bool enableDetectUnfinishedJob, Color gridColor, Color highestVolumeCellColor, Color imbalanceClusterAskLineColor, Color imbalanceClusterBidLineColor, int imbalanceClusterBoxSize, DashStyle imbalanceClusterLineDashStyle, int imbalanceClusterLineWidth, int imbalanceClusterSize, int imbalanceInPercent, Color imbalanceTextColorAsk, Color imbalanceTextColorBid, int imbalanceVolumeThreshold, Color ladderAskBarStripeColor, Color ladderAskCellBackgroundColor, Color ladderBidBarStripeColor, Color ladderBidCellBackgroundColor, bool loadHistoricalData, bool markHighestVolumeCellColor, double ratioBoundsHigh, double ratioBoundsLow, Font ratioFont, Color ratioOutOfBoundsColor, Color singlePrintBoxColorBottom, int singlePrintBoxColorOpacity, Color singlePrintBoxColorTop, int sizeFilter, Color summaryAskCellBackgroundColor, Color summaryBidCellBackgroundColor, Color summaryDeltaCellBackgroundColor, Font summaryFont, Color summaryHeaderColor, Color summaryVolumeCellBackgroundColor, Color textColor, Color unfinishedJobHighLineColor, DashStyle unfinishedJobLineDashStyle, int unfinishedJobLineWidth, Color unfinishedJobLowLineColor, Font volumeImbalanceFont, Color volumeProfileAskColor, Color volumeProfileBidColor, int volumeProfileOpacity, Color volumeProfileTotalColor)
        {
            if (cacheOrderFlowsTrader != null)
                for (int idx = 0; idx < cacheOrderFlowsTrader.Length; idx++)
                    if (cacheOrderFlowsTrader[idx].BarDisplayType == barDisplayType && cacheOrderFlowsTrader[idx].BidAskHistogramSize == bidAskHistogramSize && cacheOrderFlowsTrader[idx].BlockTradeAskLineColor == blockTradeAskLineColor && cacheOrderFlowsTrader[idx].BlockTradeBidLineColor == blockTradeBidLineColor && cacheOrderFlowsTrader[idx].BlockTradeFont == blockTradeFont && cacheOrderFlowsTrader[idx].BlockTradeLineDashStyle == blockTradeLineDashStyle && cacheOrderFlowsTrader[idx].BlockTradeLineWidth == blockTradeLineWidth && cacheOrderFlowsTrader[idx].BlockTradeSizeFilter == blockTradeSizeFilter && cacheOrderFlowsTrader[idx].DisplayImbalanceClusters == displayImbalanceClusters && cacheOrderFlowsTrader[idx].DisplayReversalBar == displayReversalBar && cacheOrderFlowsTrader[idx].DisplaySummaryPanelAsk == displaySummaryPanelAsk && cacheOrderFlowsTrader[idx].DisplaySummaryPanelBarVolume == displaySummaryPanelBarVolume && cacheOrderFlowsTrader[idx].DisplaySummaryPanelBid == displaySummaryPanelBid && cacheOrderFlowsTrader[idx].DisplaySummaryPanelCumDelta == displaySummaryPanelCumDelta && cacheOrderFlowsTrader[idx].DisplaySummaryPanelCumDeltaByVolume == displaySummaryPanelCumDeltaByVolume && cacheOrderFlowsTrader[idx].DisplaySummaryPanelDelta == displaySummaryPanelDelta && cacheOrderFlowsTrader[idx].DisplaySummaryPanelMaxDelta == displaySummaryPanelMaxDelta && cacheOrderFlowsTrader[idx].DisplaySummaryPanelMinDelta == displaySummaryPanelMinDelta && cacheOrderFlowsTrader[idx].DisplaySummaryPanelTotalVolume == displaySummaryPanelTotalVolume && cacheOrderFlowsTrader[idx].DisplayVolumeProfile == displayVolumeProfile && cacheOrderFlowsTrader[idx].EnableDetectUnfinishedJob == enableDetectUnfinishedJob && cacheOrderFlowsTrader[idx].GridColor == gridColor && cacheOrderFlowsTrader[idx].HighestVolumeCellColor == highestVolumeCellColor && cacheOrderFlowsTrader[idx].ImbalanceClusterAskLineColor == imbalanceClusterAskLineColor && cacheOrderFlowsTrader[idx].ImbalanceClusterBidLineColor == imbalanceClusterBidLineColor && cacheOrderFlowsTrader[idx].ImbalanceClusterBoxSize == imbalanceClusterBoxSize && cacheOrderFlowsTrader[idx].ImbalanceClusterLineDashStyle == imbalanceClusterLineDashStyle && cacheOrderFlowsTrader[idx].ImbalanceClusterLineWidth == imbalanceClusterLineWidth && cacheOrderFlowsTrader[idx].ImbalanceClusterSize == imbalanceClusterSize && cacheOrderFlowsTrader[idx].ImbalanceInPercent == imbalanceInPercent && cacheOrderFlowsTrader[idx].ImbalanceTextColorAsk == imbalanceTextColorAsk && cacheOrderFlowsTrader[idx].ImbalanceTextColorBid == imbalanceTextColorBid && cacheOrderFlowsTrader[idx].ImbalanceVolumeThreshold == imbalanceVolumeThreshold && cacheOrderFlowsTrader[idx].LadderAskBarStripeColor == ladderAskBarStripeColor && cacheOrderFlowsTrader[idx].LadderAskCellBackgroundColor == ladderAskCellBackgroundColor && cacheOrderFlowsTrader[idx].LadderBidBarStripeColor == ladderBidBarStripeColor && cacheOrderFlowsTrader[idx].LadderBidCellBackgroundColor == ladderBidCellBackgroundColor && cacheOrderFlowsTrader[idx].LoadHistoricalData == loadHistoricalData && cacheOrderFlowsTrader[idx].MarkHighestVolumeCellColor == markHighestVolumeCellColor && Math.Abs(cacheOrderFlowsTrader[idx].RatioBoundsHigh - ratioBoundsHigh) <= double.Epsilon && Math.Abs(cacheOrderFlowsTrader[idx].RatioBoundsLow - ratioBoundsLow) <= double.Epsilon && cacheOrderFlowsTrader[idx].RatioFont == ratioFont && cacheOrderFlowsTrader[idx].RatioOutOfBoundsColor == ratioOutOfBoundsColor && cacheOrderFlowsTrader[idx].SinglePrintBoxColorBottom == singlePrintBoxColorBottom && cacheOrderFlowsTrader[idx].SinglePrintBoxColorOpacity == singlePrintBoxColorOpacity && cacheOrderFlowsTrader[idx].SinglePrintBoxColorTop == singlePrintBoxColorTop && cacheOrderFlowsTrader[idx].SizeFilter == sizeFilter && cacheOrderFlowsTrader[idx].SummaryAskCellBackgroundColor == summaryAskCellBackgroundColor && cacheOrderFlowsTrader[idx].SummaryBidCellBackgroundColor == summaryBidCellBackgroundColor && cacheOrderFlowsTrader[idx].SummaryDeltaCellBackgroundColor == summaryDeltaCellBackgroundColor && cacheOrderFlowsTrader[idx].SummaryFont == summaryFont && cacheOrderFlowsTrader[idx].SummaryHeaderColor == summaryHeaderColor && cacheOrderFlowsTrader[idx].SummaryVolumeCellBackgroundColor == summaryVolumeCellBackgroundColor && cacheOrderFlowsTrader[idx].TextColor == textColor && cacheOrderFlowsTrader[idx].UnfinishedJobHighLineColor == unfinishedJobHighLineColor && cacheOrderFlowsTrader[idx].UnfinishedJobLineDashStyle == unfinishedJobLineDashStyle && cacheOrderFlowsTrader[idx].UnfinishedJobLineWidth == unfinishedJobLineWidth && cacheOrderFlowsTrader[idx].UnfinishedJobLowLineColor == unfinishedJobLowLineColor && cacheOrderFlowsTrader[idx].VolumeImbalanceFont == volumeImbalanceFont && cacheOrderFlowsTrader[idx].VolumeProfileAskColor == volumeProfileAskColor && cacheOrderFlowsTrader[idx].VolumeProfileBidColor == volumeProfileBidColor && cacheOrderFlowsTrader[idx].VolumeProfileOpacity == volumeProfileOpacity && cacheOrderFlowsTrader[idx].VolumeProfileTotalColor == volumeProfileTotalColor && cacheOrderFlowsTrader[idx].EqualsInput(input))
                        return cacheOrderFlowsTrader[idx];

            lock (checkOrderFlowsTrader)
            {
                checkOrderFlowsTrader.BarDisplayType = barDisplayType;
                barDisplayType = checkOrderFlowsTrader.BarDisplayType;
                checkOrderFlowsTrader.BidAskHistogramSize = bidAskHistogramSize;
                bidAskHistogramSize = checkOrderFlowsTrader.BidAskHistogramSize;
                checkOrderFlowsTrader.BlockTradeAskLineColor = blockTradeAskLineColor;
                blockTradeAskLineColor = checkOrderFlowsTrader.BlockTradeAskLineColor;
                checkOrderFlowsTrader.BlockTradeBidLineColor = blockTradeBidLineColor;
                blockTradeBidLineColor = checkOrderFlowsTrader.BlockTradeBidLineColor;
                checkOrderFlowsTrader.BlockTradeFont = blockTradeFont;
                blockTradeFont = checkOrderFlowsTrader.BlockTradeFont;
                checkOrderFlowsTrader.BlockTradeLineDashStyle = blockTradeLineDashStyle;
                blockTradeLineDashStyle = checkOrderFlowsTrader.BlockTradeLineDashStyle;
                checkOrderFlowsTrader.BlockTradeLineWidth = blockTradeLineWidth;
                blockTradeLineWidth = checkOrderFlowsTrader.BlockTradeLineWidth;
                checkOrderFlowsTrader.BlockTradeSizeFilter = blockTradeSizeFilter;
                blockTradeSizeFilter = checkOrderFlowsTrader.BlockTradeSizeFilter;
                checkOrderFlowsTrader.DisplayImbalanceClusters = displayImbalanceClusters;
                displayImbalanceClusters = checkOrderFlowsTrader.DisplayImbalanceClusters;
                checkOrderFlowsTrader.DisplayReversalBar = displayReversalBar;
                displayReversalBar = checkOrderFlowsTrader.DisplayReversalBar;
                checkOrderFlowsTrader.DisplaySummaryPanelAsk = displaySummaryPanelAsk;
                displaySummaryPanelAsk = checkOrderFlowsTrader.DisplaySummaryPanelAsk;
                checkOrderFlowsTrader.DisplaySummaryPanelBarVolume = displaySummaryPanelBarVolume;
                displaySummaryPanelBarVolume = checkOrderFlowsTrader.DisplaySummaryPanelBarVolume;
                checkOrderFlowsTrader.DisplaySummaryPanelBid = displaySummaryPanelBid;
                displaySummaryPanelBid = checkOrderFlowsTrader.DisplaySummaryPanelBid;
                checkOrderFlowsTrader.DisplaySummaryPanelCumDelta = displaySummaryPanelCumDelta;
                displaySummaryPanelCumDelta = checkOrderFlowsTrader.DisplaySummaryPanelCumDelta;
                checkOrderFlowsTrader.DisplaySummaryPanelCumDeltaByVolume = displaySummaryPanelCumDeltaByVolume;
                displaySummaryPanelCumDeltaByVolume = checkOrderFlowsTrader.DisplaySummaryPanelCumDeltaByVolume;
                checkOrderFlowsTrader.DisplaySummaryPanelDelta = displaySummaryPanelDelta;
                displaySummaryPanelDelta = checkOrderFlowsTrader.DisplaySummaryPanelDelta;
                checkOrderFlowsTrader.DisplaySummaryPanelMaxDelta = displaySummaryPanelMaxDelta;
                displaySummaryPanelMaxDelta = checkOrderFlowsTrader.DisplaySummaryPanelMaxDelta;
                checkOrderFlowsTrader.DisplaySummaryPanelMinDelta = displaySummaryPanelMinDelta;
                displaySummaryPanelMinDelta = checkOrderFlowsTrader.DisplaySummaryPanelMinDelta;
                checkOrderFlowsTrader.DisplaySummaryPanelTotalVolume = displaySummaryPanelTotalVolume;
                displaySummaryPanelTotalVolume = checkOrderFlowsTrader.DisplaySummaryPanelTotalVolume;
                checkOrderFlowsTrader.DisplayVolumeProfile = displayVolumeProfile;
                displayVolumeProfile = checkOrderFlowsTrader.DisplayVolumeProfile;
                checkOrderFlowsTrader.EnableDetectUnfinishedJob = enableDetectUnfinishedJob;
                enableDetectUnfinishedJob = checkOrderFlowsTrader.EnableDetectUnfinishedJob;
                checkOrderFlowsTrader.GridColor = gridColor;
                gridColor = checkOrderFlowsTrader.GridColor;
                checkOrderFlowsTrader.HighestVolumeCellColor = highestVolumeCellColor;
                highestVolumeCellColor = checkOrderFlowsTrader.HighestVolumeCellColor;
                checkOrderFlowsTrader.ImbalanceClusterAskLineColor = imbalanceClusterAskLineColor;
                imbalanceClusterAskLineColor = checkOrderFlowsTrader.ImbalanceClusterAskLineColor;
                checkOrderFlowsTrader.ImbalanceClusterBidLineColor = imbalanceClusterBidLineColor;
                imbalanceClusterBidLineColor = checkOrderFlowsTrader.ImbalanceClusterBidLineColor;
                checkOrderFlowsTrader.ImbalanceClusterBoxSize = imbalanceClusterBoxSize;
                imbalanceClusterBoxSize = checkOrderFlowsTrader.ImbalanceClusterBoxSize;
                checkOrderFlowsTrader.ImbalanceClusterLineDashStyle = imbalanceClusterLineDashStyle;
                imbalanceClusterLineDashStyle = checkOrderFlowsTrader.ImbalanceClusterLineDashStyle;
                checkOrderFlowsTrader.ImbalanceClusterLineWidth = imbalanceClusterLineWidth;
                imbalanceClusterLineWidth = checkOrderFlowsTrader.ImbalanceClusterLineWidth;
                checkOrderFlowsTrader.ImbalanceClusterSize = imbalanceClusterSize;
                imbalanceClusterSize = checkOrderFlowsTrader.ImbalanceClusterSize;
                checkOrderFlowsTrader.ImbalanceInPercent = imbalanceInPercent;
                imbalanceInPercent = checkOrderFlowsTrader.ImbalanceInPercent;
                checkOrderFlowsTrader.ImbalanceTextColorAsk = imbalanceTextColorAsk;
                imbalanceTextColorAsk = checkOrderFlowsTrader.ImbalanceTextColorAsk;
                checkOrderFlowsTrader.ImbalanceTextColorBid = imbalanceTextColorBid;
                imbalanceTextColorBid = checkOrderFlowsTrader.ImbalanceTextColorBid;
                checkOrderFlowsTrader.ImbalanceVolumeThreshold = imbalanceVolumeThreshold;
                imbalanceVolumeThreshold = checkOrderFlowsTrader.ImbalanceVolumeThreshold;
                checkOrderFlowsTrader.LadderAskBarStripeColor = ladderAskBarStripeColor;
                ladderAskBarStripeColor = checkOrderFlowsTrader.LadderAskBarStripeColor;
                checkOrderFlowsTrader.LadderAskCellBackgroundColor = ladderAskCellBackgroundColor;
                ladderAskCellBackgroundColor = checkOrderFlowsTrader.LadderAskCellBackgroundColor;
                checkOrderFlowsTrader.LadderBidBarStripeColor = ladderBidBarStripeColor;
                ladderBidBarStripeColor = checkOrderFlowsTrader.LadderBidBarStripeColor;
                checkOrderFlowsTrader.LadderBidCellBackgroundColor = ladderBidCellBackgroundColor;
                ladderBidCellBackgroundColor = checkOrderFlowsTrader.LadderBidCellBackgroundColor;
                checkOrderFlowsTrader.LoadHistoricalData = loadHistoricalData;
                loadHistoricalData = checkOrderFlowsTrader.LoadHistoricalData;
                checkOrderFlowsTrader.MarkHighestVolumeCellColor = markHighestVolumeCellColor;
                markHighestVolumeCellColor = checkOrderFlowsTrader.MarkHighestVolumeCellColor;
                checkOrderFlowsTrader.RatioBoundsHigh = ratioBoundsHigh;
                ratioBoundsHigh = checkOrderFlowsTrader.RatioBoundsHigh;
                checkOrderFlowsTrader.RatioBoundsLow = ratioBoundsLow;
                ratioBoundsLow = checkOrderFlowsTrader.RatioBoundsLow;
                checkOrderFlowsTrader.RatioFont = ratioFont;
                ratioFont = checkOrderFlowsTrader.RatioFont;
                checkOrderFlowsTrader.RatioOutOfBoundsColor = ratioOutOfBoundsColor;
                ratioOutOfBoundsColor = checkOrderFlowsTrader.RatioOutOfBoundsColor;
                checkOrderFlowsTrader.SinglePrintBoxColorBottom = singlePrintBoxColorBottom;
                singlePrintBoxColorBottom = checkOrderFlowsTrader.SinglePrintBoxColorBottom;
                checkOrderFlowsTrader.SinglePrintBoxColorOpacity = singlePrintBoxColorOpacity;
                singlePrintBoxColorOpacity = checkOrderFlowsTrader.SinglePrintBoxColorOpacity;
                checkOrderFlowsTrader.SinglePrintBoxColorTop = singlePrintBoxColorTop;
                singlePrintBoxColorTop = checkOrderFlowsTrader.SinglePrintBoxColorTop;
                checkOrderFlowsTrader.SizeFilter = sizeFilter;
                sizeFilter = checkOrderFlowsTrader.SizeFilter;
                checkOrderFlowsTrader.SummaryAskCellBackgroundColor = summaryAskCellBackgroundColor;
                summaryAskCellBackgroundColor = checkOrderFlowsTrader.SummaryAskCellBackgroundColor;
                checkOrderFlowsTrader.SummaryBidCellBackgroundColor = summaryBidCellBackgroundColor;
                summaryBidCellBackgroundColor = checkOrderFlowsTrader.SummaryBidCellBackgroundColor;
                checkOrderFlowsTrader.SummaryDeltaCellBackgroundColor = summaryDeltaCellBackgroundColor;
                summaryDeltaCellBackgroundColor = checkOrderFlowsTrader.SummaryDeltaCellBackgroundColor;
                checkOrderFlowsTrader.SummaryFont = summaryFont;
                summaryFont = checkOrderFlowsTrader.SummaryFont;
                checkOrderFlowsTrader.SummaryHeaderColor = summaryHeaderColor;
                summaryHeaderColor = checkOrderFlowsTrader.SummaryHeaderColor;
                checkOrderFlowsTrader.SummaryVolumeCellBackgroundColor = summaryVolumeCellBackgroundColor;
                summaryVolumeCellBackgroundColor = checkOrderFlowsTrader.SummaryVolumeCellBackgroundColor;
                checkOrderFlowsTrader.TextColor = textColor;
                textColor = checkOrderFlowsTrader.TextColor;
                checkOrderFlowsTrader.UnfinishedJobHighLineColor = unfinishedJobHighLineColor;
                unfinishedJobHighLineColor = checkOrderFlowsTrader.UnfinishedJobHighLineColor;
                checkOrderFlowsTrader.UnfinishedJobLineDashStyle = unfinishedJobLineDashStyle;
                unfinishedJobLineDashStyle = checkOrderFlowsTrader.UnfinishedJobLineDashStyle;
                checkOrderFlowsTrader.UnfinishedJobLineWidth = unfinishedJobLineWidth;
                unfinishedJobLineWidth = checkOrderFlowsTrader.UnfinishedJobLineWidth;
                checkOrderFlowsTrader.UnfinishedJobLowLineColor = unfinishedJobLowLineColor;
                unfinishedJobLowLineColor = checkOrderFlowsTrader.UnfinishedJobLowLineColor;
                checkOrderFlowsTrader.VolumeImbalanceFont = volumeImbalanceFont;
                volumeImbalanceFont = checkOrderFlowsTrader.VolumeImbalanceFont;
                checkOrderFlowsTrader.VolumeProfileAskColor = volumeProfileAskColor;
                volumeProfileAskColor = checkOrderFlowsTrader.VolumeProfileAskColor;
                checkOrderFlowsTrader.VolumeProfileBidColor = volumeProfileBidColor;
                volumeProfileBidColor = checkOrderFlowsTrader.VolumeProfileBidColor;
                checkOrderFlowsTrader.VolumeProfileOpacity = volumeProfileOpacity;
                volumeProfileOpacity = checkOrderFlowsTrader.VolumeProfileOpacity;
                checkOrderFlowsTrader.VolumeProfileTotalColor = volumeProfileTotalColor;
                volumeProfileTotalColor = checkOrderFlowsTrader.VolumeProfileTotalColor;

                if (cacheOrderFlowsTrader != null)
                    for (int idx = 0; idx < cacheOrderFlowsTrader.Length; idx++)
                        if (cacheOrderFlowsTrader[idx].BarDisplayType == barDisplayType && cacheOrderFlowsTrader[idx].BidAskHistogramSize == bidAskHistogramSize && cacheOrderFlowsTrader[idx].BlockTradeAskLineColor == blockTradeAskLineColor && cacheOrderFlowsTrader[idx].BlockTradeBidLineColor == blockTradeBidLineColor && cacheOrderFlowsTrader[idx].BlockTradeFont == blockTradeFont && cacheOrderFlowsTrader[idx].BlockTradeLineDashStyle == blockTradeLineDashStyle && cacheOrderFlowsTrader[idx].BlockTradeLineWidth == blockTradeLineWidth && cacheOrderFlowsTrader[idx].BlockTradeSizeFilter == blockTradeSizeFilter && cacheOrderFlowsTrader[idx].DisplayImbalanceClusters == displayImbalanceClusters && cacheOrderFlowsTrader[idx].DisplayReversalBar == displayReversalBar && cacheOrderFlowsTrader[idx].DisplaySummaryPanelAsk == displaySummaryPanelAsk && cacheOrderFlowsTrader[idx].DisplaySummaryPanelBarVolume == displaySummaryPanelBarVolume && cacheOrderFlowsTrader[idx].DisplaySummaryPanelBid == displaySummaryPanelBid && cacheOrderFlowsTrader[idx].DisplaySummaryPanelCumDelta == displaySummaryPanelCumDelta && cacheOrderFlowsTrader[idx].DisplaySummaryPanelCumDeltaByVolume == displaySummaryPanelCumDeltaByVolume && cacheOrderFlowsTrader[idx].DisplaySummaryPanelDelta == displaySummaryPanelDelta && cacheOrderFlowsTrader[idx].DisplaySummaryPanelMaxDelta == displaySummaryPanelMaxDelta && cacheOrderFlowsTrader[idx].DisplaySummaryPanelMinDelta == displaySummaryPanelMinDelta && cacheOrderFlowsTrader[idx].DisplaySummaryPanelTotalVolume == displaySummaryPanelTotalVolume && cacheOrderFlowsTrader[idx].DisplayVolumeProfile == displayVolumeProfile && cacheOrderFlowsTrader[idx].EnableDetectUnfinishedJob == enableDetectUnfinishedJob && cacheOrderFlowsTrader[idx].GridColor == gridColor && cacheOrderFlowsTrader[idx].HighestVolumeCellColor == highestVolumeCellColor && cacheOrderFlowsTrader[idx].ImbalanceClusterAskLineColor == imbalanceClusterAskLineColor && cacheOrderFlowsTrader[idx].ImbalanceClusterBidLineColor == imbalanceClusterBidLineColor && cacheOrderFlowsTrader[idx].ImbalanceClusterBoxSize == imbalanceClusterBoxSize && cacheOrderFlowsTrader[idx].ImbalanceClusterLineDashStyle == imbalanceClusterLineDashStyle && cacheOrderFlowsTrader[idx].ImbalanceClusterLineWidth == imbalanceClusterLineWidth && cacheOrderFlowsTrader[idx].ImbalanceClusterSize == imbalanceClusterSize && cacheOrderFlowsTrader[idx].ImbalanceInPercent == imbalanceInPercent && cacheOrderFlowsTrader[idx].ImbalanceTextColorAsk == imbalanceTextColorAsk && cacheOrderFlowsTrader[idx].ImbalanceTextColorBid == imbalanceTextColorBid && cacheOrderFlowsTrader[idx].ImbalanceVolumeThreshold == imbalanceVolumeThreshold && cacheOrderFlowsTrader[idx].LadderAskBarStripeColor == ladderAskBarStripeColor && cacheOrderFlowsTrader[idx].LadderAskCellBackgroundColor == ladderAskCellBackgroundColor && cacheOrderFlowsTrader[idx].LadderBidBarStripeColor == ladderBidBarStripeColor && cacheOrderFlowsTrader[idx].LadderBidCellBackgroundColor == ladderBidCellBackgroundColor && cacheOrderFlowsTrader[idx].LoadHistoricalData == loadHistoricalData && cacheOrderFlowsTrader[idx].MarkHighestVolumeCellColor == markHighestVolumeCellColor && Math.Abs(cacheOrderFlowsTrader[idx].RatioBoundsHigh - ratioBoundsHigh) <= double.Epsilon && Math.Abs(cacheOrderFlowsTrader[idx].RatioBoundsLow - ratioBoundsLow) <= double.Epsilon && cacheOrderFlowsTrader[idx].RatioFont == ratioFont && cacheOrderFlowsTrader[idx].RatioOutOfBoundsColor == ratioOutOfBoundsColor && cacheOrderFlowsTrader[idx].SinglePrintBoxColorBottom == singlePrintBoxColorBottom && cacheOrderFlowsTrader[idx].SinglePrintBoxColorOpacity == singlePrintBoxColorOpacity && cacheOrderFlowsTrader[idx].SinglePrintBoxColorTop == singlePrintBoxColorTop && cacheOrderFlowsTrader[idx].SizeFilter == sizeFilter && cacheOrderFlowsTrader[idx].SummaryAskCellBackgroundColor == summaryAskCellBackgroundColor && cacheOrderFlowsTrader[idx].SummaryBidCellBackgroundColor == summaryBidCellBackgroundColor && cacheOrderFlowsTrader[idx].SummaryDeltaCellBackgroundColor == summaryDeltaCellBackgroundColor && cacheOrderFlowsTrader[idx].SummaryFont == summaryFont && cacheOrderFlowsTrader[idx].SummaryHeaderColor == summaryHeaderColor && cacheOrderFlowsTrader[idx].SummaryVolumeCellBackgroundColor == summaryVolumeCellBackgroundColor && cacheOrderFlowsTrader[idx].TextColor == textColor && cacheOrderFlowsTrader[idx].UnfinishedJobHighLineColor == unfinishedJobHighLineColor && cacheOrderFlowsTrader[idx].UnfinishedJobLineDashStyle == unfinishedJobLineDashStyle && cacheOrderFlowsTrader[idx].UnfinishedJobLineWidth == unfinishedJobLineWidth && cacheOrderFlowsTrader[idx].UnfinishedJobLowLineColor == unfinishedJobLowLineColor && cacheOrderFlowsTrader[idx].VolumeImbalanceFont == volumeImbalanceFont && cacheOrderFlowsTrader[idx].VolumeProfileAskColor == volumeProfileAskColor && cacheOrderFlowsTrader[idx].VolumeProfileBidColor == volumeProfileBidColor && cacheOrderFlowsTrader[idx].VolumeProfileOpacity == volumeProfileOpacity && cacheOrderFlowsTrader[idx].VolumeProfileTotalColor == volumeProfileTotalColor && cacheOrderFlowsTrader[idx].EqualsInput(input))
                            return cacheOrderFlowsTrader[idx];

                OrderFlowsTrader indicator = new OrderFlowsTrader();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.BarDisplayType = barDisplayType;
                indicator.BidAskHistogramSize = bidAskHistogramSize;
                indicator.BlockTradeAskLineColor = blockTradeAskLineColor;
                indicator.BlockTradeBidLineColor = blockTradeBidLineColor;
                indicator.BlockTradeFont = blockTradeFont;
                indicator.BlockTradeLineDashStyle = blockTradeLineDashStyle;
                indicator.BlockTradeLineWidth = blockTradeLineWidth;
                indicator.BlockTradeSizeFilter = blockTradeSizeFilter;
                indicator.DisplayImbalanceClusters = displayImbalanceClusters;
                indicator.DisplayReversalBar = displayReversalBar;
                indicator.DisplaySummaryPanelAsk = displaySummaryPanelAsk;
                indicator.DisplaySummaryPanelBarVolume = displaySummaryPanelBarVolume;
                indicator.DisplaySummaryPanelBid = displaySummaryPanelBid;
                indicator.DisplaySummaryPanelCumDelta = displaySummaryPanelCumDelta;
                indicator.DisplaySummaryPanelCumDeltaByVolume = displaySummaryPanelCumDeltaByVolume;
                indicator.DisplaySummaryPanelDelta = displaySummaryPanelDelta;
                indicator.DisplaySummaryPanelMaxDelta = displaySummaryPanelMaxDelta;
                indicator.DisplaySummaryPanelMinDelta = displaySummaryPanelMinDelta;
                indicator.DisplaySummaryPanelTotalVolume = displaySummaryPanelTotalVolume;
                indicator.DisplayVolumeProfile = displayVolumeProfile;
                indicator.EnableDetectUnfinishedJob = enableDetectUnfinishedJob;
                indicator.GridColor = gridColor;
                indicator.HighestVolumeCellColor = highestVolumeCellColor;
                indicator.ImbalanceClusterAskLineColor = imbalanceClusterAskLineColor;
                indicator.ImbalanceClusterBidLineColor = imbalanceClusterBidLineColor;
                indicator.ImbalanceClusterBoxSize = imbalanceClusterBoxSize;
                indicator.ImbalanceClusterLineDashStyle = imbalanceClusterLineDashStyle;
                indicator.ImbalanceClusterLineWidth = imbalanceClusterLineWidth;
                indicator.ImbalanceClusterSize = imbalanceClusterSize;
                indicator.ImbalanceInPercent = imbalanceInPercent;
                indicator.ImbalanceTextColorAsk = imbalanceTextColorAsk;
                indicator.ImbalanceTextColorBid = imbalanceTextColorBid;
                indicator.ImbalanceVolumeThreshold = imbalanceVolumeThreshold;
                indicator.LadderAskBarStripeColor = ladderAskBarStripeColor;
                indicator.LadderAskCellBackgroundColor = ladderAskCellBackgroundColor;
                indicator.LadderBidBarStripeColor = ladderBidBarStripeColor;
                indicator.LadderBidCellBackgroundColor = ladderBidCellBackgroundColor;
                indicator.LoadHistoricalData = loadHistoricalData;
                indicator.MarkHighestVolumeCellColor = markHighestVolumeCellColor;
                indicator.RatioBoundsHigh = ratioBoundsHigh;
                indicator.RatioBoundsLow = ratioBoundsLow;
                indicator.RatioFont = ratioFont;
                indicator.RatioOutOfBoundsColor = ratioOutOfBoundsColor;
                indicator.SinglePrintBoxColorBottom = singlePrintBoxColorBottom;
                indicator.SinglePrintBoxColorOpacity = singlePrintBoxColorOpacity;
                indicator.SinglePrintBoxColorTop = singlePrintBoxColorTop;
                indicator.SizeFilter = sizeFilter;
                indicator.SummaryAskCellBackgroundColor = summaryAskCellBackgroundColor;
                indicator.SummaryBidCellBackgroundColor = summaryBidCellBackgroundColor;
                indicator.SummaryDeltaCellBackgroundColor = summaryDeltaCellBackgroundColor;
                indicator.SummaryFont = summaryFont;
                indicator.SummaryHeaderColor = summaryHeaderColor;
                indicator.SummaryVolumeCellBackgroundColor = summaryVolumeCellBackgroundColor;
                indicator.TextColor = textColor;
                indicator.UnfinishedJobHighLineColor = unfinishedJobHighLineColor;
                indicator.UnfinishedJobLineDashStyle = unfinishedJobLineDashStyle;
                indicator.UnfinishedJobLineWidth = unfinishedJobLineWidth;
                indicator.UnfinishedJobLowLineColor = unfinishedJobLowLineColor;
                indicator.VolumeImbalanceFont = volumeImbalanceFont;
                indicator.VolumeProfileAskColor = volumeProfileAskColor;
                indicator.VolumeProfileBidColor = volumeProfileBidColor;
                indicator.VolumeProfileOpacity = volumeProfileOpacity;
                indicator.VolumeProfileTotalColor = volumeProfileTotalColor;
                Indicators.Add(indicator);
                indicator.SetUp();

                OrderFlowsTrader[] tmp = new OrderFlowsTrader[cacheOrderFlowsTrader == null ? 1 : cacheOrderFlowsTrader.Length + 1];
                if (cacheOrderFlowsTrader != null)
                    cacheOrderFlowsTrader.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheOrderFlowsTrader = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.OrderFlowsTrader OrderFlowsTrader(NinjaTrader.Indicator.OrderFlowsTrader.BarDisplayTypeEnum barDisplayType, int bidAskHistogramSize, Color blockTradeAskLineColor, Color blockTradeBidLineColor, Font blockTradeFont, DashStyle blockTradeLineDashStyle, int blockTradeLineWidth, int blockTradeSizeFilter, bool displayImbalanceClusters, bool displayReversalBar, bool displaySummaryPanelAsk, bool displaySummaryPanelBarVolume, bool displaySummaryPanelBid, bool displaySummaryPanelCumDelta, bool displaySummaryPanelCumDeltaByVolume, bool displaySummaryPanelDelta, bool displaySummaryPanelMaxDelta, bool displaySummaryPanelMinDelta, bool displaySummaryPanelTotalVolume, bool displayVolumeProfile, bool enableDetectUnfinishedJob, Color gridColor, Color highestVolumeCellColor, Color imbalanceClusterAskLineColor, Color imbalanceClusterBidLineColor, int imbalanceClusterBoxSize, DashStyle imbalanceClusterLineDashStyle, int imbalanceClusterLineWidth, int imbalanceClusterSize, int imbalanceInPercent, Color imbalanceTextColorAsk, Color imbalanceTextColorBid, int imbalanceVolumeThreshold, Color ladderAskBarStripeColor, Color ladderAskCellBackgroundColor, Color ladderBidBarStripeColor, Color ladderBidCellBackgroundColor, bool loadHistoricalData, bool markHighestVolumeCellColor, double ratioBoundsHigh, double ratioBoundsLow, Font ratioFont, Color ratioOutOfBoundsColor, Color singlePrintBoxColorBottom, int singlePrintBoxColorOpacity, Color singlePrintBoxColorTop, int sizeFilter, Color summaryAskCellBackgroundColor, Color summaryBidCellBackgroundColor, Color summaryDeltaCellBackgroundColor, Font summaryFont, Color summaryHeaderColor, Color summaryVolumeCellBackgroundColor, Color textColor, Color unfinishedJobHighLineColor, DashStyle unfinishedJobLineDashStyle, int unfinishedJobLineWidth, Color unfinishedJobLowLineColor, Font volumeImbalanceFont, Color volumeProfileAskColor, Color volumeProfileBidColor, int volumeProfileOpacity, Color volumeProfileTotalColor)
        {
            return _indicator.OrderFlowsTrader(Input, barDisplayType, bidAskHistogramSize, blockTradeAskLineColor, blockTradeBidLineColor, blockTradeFont, blockTradeLineDashStyle, blockTradeLineWidth, blockTradeSizeFilter, displayImbalanceClusters, displayReversalBar, displaySummaryPanelAsk, displaySummaryPanelBarVolume, displaySummaryPanelBid, displaySummaryPanelCumDelta, displaySummaryPanelCumDeltaByVolume, displaySummaryPanelDelta, displaySummaryPanelMaxDelta, displaySummaryPanelMinDelta, displaySummaryPanelTotalVolume, displayVolumeProfile, enableDetectUnfinishedJob, gridColor, highestVolumeCellColor, imbalanceClusterAskLineColor, imbalanceClusterBidLineColor, imbalanceClusterBoxSize, imbalanceClusterLineDashStyle, imbalanceClusterLineWidth, imbalanceClusterSize, imbalanceInPercent, imbalanceTextColorAsk, imbalanceTextColorBid, imbalanceVolumeThreshold, ladderAskBarStripeColor, ladderAskCellBackgroundColor, ladderBidBarStripeColor, ladderBidCellBackgroundColor, loadHistoricalData, markHighestVolumeCellColor, ratioBoundsHigh, ratioBoundsLow, ratioFont, ratioOutOfBoundsColor, singlePrintBoxColorBottom, singlePrintBoxColorOpacity, singlePrintBoxColorTop, sizeFilter, summaryAskCellBackgroundColor, summaryBidCellBackgroundColor, summaryDeltaCellBackgroundColor, summaryFont, summaryHeaderColor, summaryVolumeCellBackgroundColor, textColor, unfinishedJobHighLineColor, unfinishedJobLineDashStyle, unfinishedJobLineWidth, unfinishedJobLowLineColor, volumeImbalanceFont, volumeProfileAskColor, volumeProfileBidColor, volumeProfileOpacity, volumeProfileTotalColor);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.OrderFlowsTrader OrderFlowsTrader(Data.IDataSeries input, NinjaTrader.Indicator.OrderFlowsTrader.BarDisplayTypeEnum barDisplayType, int bidAskHistogramSize, Color blockTradeAskLineColor, Color blockTradeBidLineColor, Font blockTradeFont, DashStyle blockTradeLineDashStyle, int blockTradeLineWidth, int blockTradeSizeFilter, bool displayImbalanceClusters, bool displayReversalBar, bool displaySummaryPanelAsk, bool displaySummaryPanelBarVolume, bool displaySummaryPanelBid, bool displaySummaryPanelCumDelta, bool displaySummaryPanelCumDeltaByVolume, bool displaySummaryPanelDelta, bool displaySummaryPanelMaxDelta, bool displaySummaryPanelMinDelta, bool displaySummaryPanelTotalVolume, bool displayVolumeProfile, bool enableDetectUnfinishedJob, Color gridColor, Color highestVolumeCellColor, Color imbalanceClusterAskLineColor, Color imbalanceClusterBidLineColor, int imbalanceClusterBoxSize, DashStyle imbalanceClusterLineDashStyle, int imbalanceClusterLineWidth, int imbalanceClusterSize, int imbalanceInPercent, Color imbalanceTextColorAsk, Color imbalanceTextColorBid, int imbalanceVolumeThreshold, Color ladderAskBarStripeColor, Color ladderAskCellBackgroundColor, Color ladderBidBarStripeColor, Color ladderBidCellBackgroundColor, bool loadHistoricalData, bool markHighestVolumeCellColor, double ratioBoundsHigh, double ratioBoundsLow, Font ratioFont, Color ratioOutOfBoundsColor, Color singlePrintBoxColorBottom, int singlePrintBoxColorOpacity, Color singlePrintBoxColorTop, int sizeFilter, Color summaryAskCellBackgroundColor, Color summaryBidCellBackgroundColor, Color summaryDeltaCellBackgroundColor, Font summaryFont, Color summaryHeaderColor, Color summaryVolumeCellBackgroundColor, Color textColor, Color unfinishedJobHighLineColor, DashStyle unfinishedJobLineDashStyle, int unfinishedJobLineWidth, Color unfinishedJobLowLineColor, Font volumeImbalanceFont, Color volumeProfileAskColor, Color volumeProfileBidColor, int volumeProfileOpacity, Color volumeProfileTotalColor)
        {
            return _indicator.OrderFlowsTrader(input, barDisplayType, bidAskHistogramSize, blockTradeAskLineColor, blockTradeBidLineColor, blockTradeFont, blockTradeLineDashStyle, blockTradeLineWidth, blockTradeSizeFilter, displayImbalanceClusters, displayReversalBar, displaySummaryPanelAsk, displaySummaryPanelBarVolume, displaySummaryPanelBid, displaySummaryPanelCumDelta, displaySummaryPanelCumDeltaByVolume, displaySummaryPanelDelta, displaySummaryPanelMaxDelta, displaySummaryPanelMinDelta, displaySummaryPanelTotalVolume, displayVolumeProfile, enableDetectUnfinishedJob, gridColor, highestVolumeCellColor, imbalanceClusterAskLineColor, imbalanceClusterBidLineColor, imbalanceClusterBoxSize, imbalanceClusterLineDashStyle, imbalanceClusterLineWidth, imbalanceClusterSize, imbalanceInPercent, imbalanceTextColorAsk, imbalanceTextColorBid, imbalanceVolumeThreshold, ladderAskBarStripeColor, ladderAskCellBackgroundColor, ladderBidBarStripeColor, ladderBidCellBackgroundColor, loadHistoricalData, markHighestVolumeCellColor, ratioBoundsHigh, ratioBoundsLow, ratioFont, ratioOutOfBoundsColor, singlePrintBoxColorBottom, singlePrintBoxColorOpacity, singlePrintBoxColorTop, sizeFilter, summaryAskCellBackgroundColor, summaryBidCellBackgroundColor, summaryDeltaCellBackgroundColor, summaryFont, summaryHeaderColor, summaryVolumeCellBackgroundColor, textColor, unfinishedJobHighLineColor, unfinishedJobLineDashStyle, unfinishedJobLineWidth, unfinishedJobLowLineColor, volumeImbalanceFont, volumeProfileAskColor, volumeProfileBidColor, volumeProfileOpacity, volumeProfileTotalColor);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.OrderFlowsTrader OrderFlowsTrader(NinjaTrader.Indicator.OrderFlowsTrader.BarDisplayTypeEnum barDisplayType, int bidAskHistogramSize, Color blockTradeAskLineColor, Color blockTradeBidLineColor, Font blockTradeFont, DashStyle blockTradeLineDashStyle, int blockTradeLineWidth, int blockTradeSizeFilter, bool displayImbalanceClusters, bool displayReversalBar, bool displaySummaryPanelAsk, bool displaySummaryPanelBarVolume, bool displaySummaryPanelBid, bool displaySummaryPanelCumDelta, bool displaySummaryPanelCumDeltaByVolume, bool displaySummaryPanelDelta, bool displaySummaryPanelMaxDelta, bool displaySummaryPanelMinDelta, bool displaySummaryPanelTotalVolume, bool displayVolumeProfile, bool enableDetectUnfinishedJob, Color gridColor, Color highestVolumeCellColor, Color imbalanceClusterAskLineColor, Color imbalanceClusterBidLineColor, int imbalanceClusterBoxSize, DashStyle imbalanceClusterLineDashStyle, int imbalanceClusterLineWidth, int imbalanceClusterSize, int imbalanceInPercent, Color imbalanceTextColorAsk, Color imbalanceTextColorBid, int imbalanceVolumeThreshold, Color ladderAskBarStripeColor, Color ladderAskCellBackgroundColor, Color ladderBidBarStripeColor, Color ladderBidCellBackgroundColor, bool loadHistoricalData, bool markHighestVolumeCellColor, double ratioBoundsHigh, double ratioBoundsLow, Font ratioFont, Color ratioOutOfBoundsColor, Color singlePrintBoxColorBottom, int singlePrintBoxColorOpacity, Color singlePrintBoxColorTop, int sizeFilter, Color summaryAskCellBackgroundColor, Color summaryBidCellBackgroundColor, Color summaryDeltaCellBackgroundColor, Font summaryFont, Color summaryHeaderColor, Color summaryVolumeCellBackgroundColor, Color textColor, Color unfinishedJobHighLineColor, DashStyle unfinishedJobLineDashStyle, int unfinishedJobLineWidth, Color unfinishedJobLowLineColor, Font volumeImbalanceFont, Color volumeProfileAskColor, Color volumeProfileBidColor, int volumeProfileOpacity, Color volumeProfileTotalColor)
        {
            return _indicator.OrderFlowsTrader(Input, barDisplayType, bidAskHistogramSize, blockTradeAskLineColor, blockTradeBidLineColor, blockTradeFont, blockTradeLineDashStyle, blockTradeLineWidth, blockTradeSizeFilter, displayImbalanceClusters, displayReversalBar, displaySummaryPanelAsk, displaySummaryPanelBarVolume, displaySummaryPanelBid, displaySummaryPanelCumDelta, displaySummaryPanelCumDeltaByVolume, displaySummaryPanelDelta, displaySummaryPanelMaxDelta, displaySummaryPanelMinDelta, displaySummaryPanelTotalVolume, displayVolumeProfile, enableDetectUnfinishedJob, gridColor, highestVolumeCellColor, imbalanceClusterAskLineColor, imbalanceClusterBidLineColor, imbalanceClusterBoxSize, imbalanceClusterLineDashStyle, imbalanceClusterLineWidth, imbalanceClusterSize, imbalanceInPercent, imbalanceTextColorAsk, imbalanceTextColorBid, imbalanceVolumeThreshold, ladderAskBarStripeColor, ladderAskCellBackgroundColor, ladderBidBarStripeColor, ladderBidCellBackgroundColor, loadHistoricalData, markHighestVolumeCellColor, ratioBoundsHigh, ratioBoundsLow, ratioFont, ratioOutOfBoundsColor, singlePrintBoxColorBottom, singlePrintBoxColorOpacity, singlePrintBoxColorTop, sizeFilter, summaryAskCellBackgroundColor, summaryBidCellBackgroundColor, summaryDeltaCellBackgroundColor, summaryFont, summaryHeaderColor, summaryVolumeCellBackgroundColor, textColor, unfinishedJobHighLineColor, unfinishedJobLineDashStyle, unfinishedJobLineWidth, unfinishedJobLowLineColor, volumeImbalanceFont, volumeProfileAskColor, volumeProfileBidColor, volumeProfileOpacity, volumeProfileTotalColor);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.OrderFlowsTrader OrderFlowsTrader(Data.IDataSeries input, NinjaTrader.Indicator.OrderFlowsTrader.BarDisplayTypeEnum barDisplayType, int bidAskHistogramSize, Color blockTradeAskLineColor, Color blockTradeBidLineColor, Font blockTradeFont, DashStyle blockTradeLineDashStyle, int blockTradeLineWidth, int blockTradeSizeFilter, bool displayImbalanceClusters, bool displayReversalBar, bool displaySummaryPanelAsk, bool displaySummaryPanelBarVolume, bool displaySummaryPanelBid, bool displaySummaryPanelCumDelta, bool displaySummaryPanelCumDeltaByVolume, bool displaySummaryPanelDelta, bool displaySummaryPanelMaxDelta, bool displaySummaryPanelMinDelta, bool displaySummaryPanelTotalVolume, bool displayVolumeProfile, bool enableDetectUnfinishedJob, Color gridColor, Color highestVolumeCellColor, Color imbalanceClusterAskLineColor, Color imbalanceClusterBidLineColor, int imbalanceClusterBoxSize, DashStyle imbalanceClusterLineDashStyle, int imbalanceClusterLineWidth, int imbalanceClusterSize, int imbalanceInPercent, Color imbalanceTextColorAsk, Color imbalanceTextColorBid, int imbalanceVolumeThreshold, Color ladderAskBarStripeColor, Color ladderAskCellBackgroundColor, Color ladderBidBarStripeColor, Color ladderBidCellBackgroundColor, bool loadHistoricalData, bool markHighestVolumeCellColor, double ratioBoundsHigh, double ratioBoundsLow, Font ratioFont, Color ratioOutOfBoundsColor, Color singlePrintBoxColorBottom, int singlePrintBoxColorOpacity, Color singlePrintBoxColorTop, int sizeFilter, Color summaryAskCellBackgroundColor, Color summaryBidCellBackgroundColor, Color summaryDeltaCellBackgroundColor, Font summaryFont, Color summaryHeaderColor, Color summaryVolumeCellBackgroundColor, Color textColor, Color unfinishedJobHighLineColor, DashStyle unfinishedJobLineDashStyle, int unfinishedJobLineWidth, Color unfinishedJobLowLineColor, Font volumeImbalanceFont, Color volumeProfileAskColor, Color volumeProfileBidColor, int volumeProfileOpacity, Color volumeProfileTotalColor)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.OrderFlowsTrader(input, barDisplayType, bidAskHistogramSize, blockTradeAskLineColor, blockTradeBidLineColor, blockTradeFont, blockTradeLineDashStyle, blockTradeLineWidth, blockTradeSizeFilter, displayImbalanceClusters, displayReversalBar, displaySummaryPanelAsk, displaySummaryPanelBarVolume, displaySummaryPanelBid, displaySummaryPanelCumDelta, displaySummaryPanelCumDeltaByVolume, displaySummaryPanelDelta, displaySummaryPanelMaxDelta, displaySummaryPanelMinDelta, displaySummaryPanelTotalVolume, displayVolumeProfile, enableDetectUnfinishedJob, gridColor, highestVolumeCellColor, imbalanceClusterAskLineColor, imbalanceClusterBidLineColor, imbalanceClusterBoxSize, imbalanceClusterLineDashStyle, imbalanceClusterLineWidth, imbalanceClusterSize, imbalanceInPercent, imbalanceTextColorAsk, imbalanceTextColorBid, imbalanceVolumeThreshold, ladderAskBarStripeColor, ladderAskCellBackgroundColor, ladderBidBarStripeColor, ladderBidCellBackgroundColor, loadHistoricalData, markHighestVolumeCellColor, ratioBoundsHigh, ratioBoundsLow, ratioFont, ratioOutOfBoundsColor, singlePrintBoxColorBottom, singlePrintBoxColorOpacity, singlePrintBoxColorTop, sizeFilter, summaryAskCellBackgroundColor, summaryBidCellBackgroundColor, summaryDeltaCellBackgroundColor, summaryFont, summaryHeaderColor, summaryVolumeCellBackgroundColor, textColor, unfinishedJobHighLineColor, unfinishedJobLineDashStyle, unfinishedJobLineWidth, unfinishedJobLowLineColor, volumeImbalanceFont, volumeProfileAskColor, volumeProfileBidColor, volumeProfileOpacity, volumeProfileTotalColor);
        }
    }
}
#endregion
